package org.dromara.system.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.system.domain.AiModelDo;
import org.springframework.stereotype.Service;
import org.dromara.system.domain.bo.AiModelBo;
import org.dromara.system.domain.vo.AiModelVo;
import org.dromara.system.mapper.AiModelMapper;
import org.dromara.system.service.IAiModelService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 模型Service业务层处理
 *
 * @author Lion Li
 * @date 2025-09-17
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class AiModelServiceImpl implements IAiModelService {

    private final AiModelMapper baseMapper;

    /**
     * 查询模型
     *
     * @param id 主键
     * @return 模型
     */
    @Override
    public AiModelVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询模型列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 模型分页列表
     */
    @Override
    public TableDataInfo<AiModelVo> queryPageList(AiModelBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<AiModelDo> lqw = buildQueryWrapper(bo);
        Page<AiModelVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的模型列表
     *
     * @param bo 查询条件
     * @return 模型列表
     */
    @Override
    public List<AiModelVo> queryList(AiModelBo bo) {
        LambdaQueryWrapper<AiModelDo> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<AiModelDo> buildQueryWrapper(AiModelBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<AiModelDo> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(AiModelDo::getId);
        lqw.like(StringUtils.isNotBlank(bo.getModelName()), AiModelDo::getModelName, bo.getModelName());
        lqw.eq(bo.getNetwork() != null, AiModelDo::getNetwork, bo.getNetwork());
        lqw.eq(StringUtils.isNotBlank(bo.getCompany()), AiModelDo::getCompany, bo.getCompany());
        lqw.eq(StringUtils.isNotBlank(bo.getIntroduce()), AiModelDo::getIntroduce, bo.getIntroduce());
        lqw.eq(bo.getStatus() != null, AiModelDo::getStatus, bo.getStatus());
        lqw.eq(bo.getSort() != null, AiModelDo::getSort, bo.getSort());
        return lqw;
    }

    /**
     * 新增模型
     *
     * @param bo 模型
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(AiModelBo bo) {
        AiModelDo add = MapstructUtils.convert(bo, AiModelDo.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改模型
     *
     * @param bo 模型
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(AiModelBo bo) {
        AiModelDo update = MapstructUtils.convert(bo, AiModelDo.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(AiModelDo entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除模型信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
